diff -r 1e55e1aa8b7f sys/netinet/tcp_input.c
--- a/sys/netinet/tcp_input.c	Sun May 04 01:33:02 2014 +0000
+++ b/sys/netinet/tcp_input.c	Fri Jul 11 13:32:06 2014 +1000
@@ -56,13 +56,16 @@
 #include "opt_ipsec.h"
 #include "opt_tcpdebug.h"
 
+#include <sys/endian.h>
 #include <sys/param.h>
 #include <sys/kernel.h>
 #include <sys/hhook.h>
+#include <sys/limits.h>
 #include <sys/malloc.h>
 #include <sys/mbuf.h>
 #include <sys/proc.h>		/* for proc0 declaration */
 #include <sys/protosw.h>
+#include <sys/sbuf.h>
 #include <sys/sdt.h>
 #include <sys/signalvar.h>
 #include <sys/socket.h>
@@ -70,6 +73,12 @@
 #include <sys/sysctl.h>
 #include <sys/syslog.h>
 #include <sys/systm.h>
+#include <sys/kdb.h>
+#include <sys/taskqueue.h>
+
+#include <sys/lock.h>
+#include <sys/mutex.h>
+#include <sys/limits.h>
 
 #include <machine/cpu.h>	/* before tcp_seq.h, for tcp_random18() */
 
@@ -112,6 +121,12 @@
 #include <netinet/tcp_offload.h>
 #endif
 
+#include <netinet/mptcp.h>
+#include <netinet/mptcp_var.h>
+#include <netinet/sctp_pcb.h>
+#include <netinet/sctp_auth.h>
+#include <netinet/sctp_constants.h>
+
 #ifdef IPSEC
 #include <netipsec/ipsec.h>
 #include <netipsec/ipsec6.h>
@@ -134,7 +149,7 @@
     &VNET_NAME(blackhole), 0,
     "Do not send RST on segments to closed ports");
 
-VNET_DEFINE(int, tcp_delack_enabled) = 1;
+VNET_DEFINE(int, tcp_delack_enabled) = 0;
 SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, delayed_ack, CTLFLAG_RW,
     &VNET_NAME(tcp_delack_enabled), 0,
     "Delay ACK to try and piggyback it onto a data packet");
@@ -215,6 +230,17 @@
     &VNET_NAME(tcp_autorcvbuf_max), 0,
     "Max size of automatic receive buffer");
 
+VNET_DEFINE(int, tcp_do_mptcp) = 1;
+#define	V_tcp_do_mptcp	VNET(tcp_do_mptcp)
+SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, mptcp, CTLFLAG_RW,
+    &VNET_NAME(tcp_do_mptcp), 0,
+    "Enable Multipath Support");
+
+MALLOC_DEFINE(M_DSSMAP, "dssmap", "Struct to hold dss maps");
+
+static VNET_DEFINE(uma_zone_t, tcp_unmapped_zone);
+#define	V_tcp_unmapped_zone		VNET(tcp_unmapped_zone)
+
 VNET_DEFINE(struct inpcbhead, tcb);
 #define	tcb6	tcb  /* for KAME src sync over BSD*'s */
 VNET_DEFINE(struct inpcbinfo, tcbinfo);
@@ -228,7 +254,7 @@
 static void	 tcp_pulloutofband(struct socket *,
 		     struct tcphdr *, struct mbuf *, int);
 static void	 tcp_xmit_timer(struct tcpcb *, int);
-static void	 tcp_newreno_partial_ack(struct tcpcb *, struct tcphdr *);
+static void	 tcp_newreno_partial_ack(struct tcpcb *, struct tcphdr *, uint32_t);
 static void inline 	tcp_fields_to_host(struct tcphdr *);
 #ifdef TCP_SIGNATURE
 static void inline 	tcp_fields_to_net(struct tcphdr *);
@@ -236,20 +262,27 @@
 			    int, struct tcpopt *, struct tcphdr *, u_int);
 #endif
 static void inline	cc_ack_received(struct tcpcb *tp, struct tcphdr *th,
-			    uint16_t type);
+			    uint16_t type, uint32_t acked);
 static void inline	cc_conn_init(struct tcpcb *tp);
 static void inline	cc_post_recovery(struct tcpcb *tp, struct tcphdr *th);
 static void inline	hhook_run_tcp_est_in(struct tcpcb *tp,
 			    struct tcphdr *th, struct tcpopt *to);
 
 /*
- * TCP statistics are stored in an "array" of counter(9)s.
+ * MPTCP functions for handling new MPTCP-generated TCP options and
+ * mptcp connection states
  */
+static void inline mp_dosubtypes(struct tcpopt *to, uint8_t subtype,
+		u_char *cp, int opt, int optlen, int flags);
+static uint64_t inline mp_get_ds_64_upper(struct mpcb *mp);
+/* TCP statistics are stored in an "array" of counter(9)s. */
 VNET_PCPUSTAT_DEFINE(struct tcpstat, tcpstat);
 VNET_PCPUSTAT_SYSINIT(tcpstat);
 SYSCTL_VNET_PCPUSTAT(_net_inet_tcp, TCPCTL_STATS, stats, struct tcpstat,
     tcpstat, "TCP statistics (struct tcpstat, netinet/tcp_var.h)");
 
+#define MSBIT_CHECK 0x80000000
+
 #ifdef VIMAGE
 VNET_PCPUSTAT_SYSUNINIT(tcpstat);
 #endif /* VIMAGE */
@@ -264,6 +297,316 @@
 	counter_u64_add(VNET(tcpstat)[statnum], 1);
 }
 
+
+/*
+ * Zone for storing tcp segments that arrive and do not belong to an existing
+ * DS-mapping. We need to buffer these segments until the mapping arrives
+ * (the segment with the mapping may have been lost).
+ *
+ * XXXNJW: Need an appropriate tunable for setting the max size of this zone
+ */
+void
+tcp_unmapped_init(void)
+{
+	V_tcp_unmapped_zone = uma_zcreate("tcpunmapped", sizeof (struct tseg_qent),
+	    NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, UMA_ZONE_NOFREE);
+	/* Set the zone limit and read back the effective value. */
+	uma_zone_set_max(V_tcp_unmapped_zone, 100);
+}
+
+void
+tcp_unmapped_flush(struct tcpcb *tp)
+{
+	struct tseg_qent *qe;
+
+	INP_WLOCK_ASSERT(tp->t_inpcb);
+	while ((qe = TAILQ_FIRST(tp->t_unmapped_segq)) != NULL) {
+		TAILQ_REMOVE(tp->t_segq, qe, tqe_q);
+		m_freem(qe->tqe_m);
+		uma_zfree(V_tcp_unmapped_zone, qe);
+	}
+}
+
+static inline uint64_t
+mp_get_ds_64_upper(struct mpcb *mp) {
+	return (mp->ds_map_max & 0xFFFFFFFF00000000);
+}
+
+static void inline
+mp_dosubtypes(struct tcpopt *to, uint8_t subtype, u_char *cp, int opt, int optlen, int flags) {
+	int byte_offset;
+	struct mp_capable mcap;
+	struct mp_join mjoin;
+
+	subtype = subtype >> 4;
+
+	switch(subtype)
+	{
+	case MPTCP_SUBTYPE_MP_CAPABLE:
+	{
+		/* XXXNJW:
+		 * have to check that the 's' bit is set
+		 * also should check for the dss csum bit (for now just ignore it...)
+		 */
+		if (optlen != MPTCP_SUBLEN_MP_CAPABLE_SYN &&
+				optlen != MPTCP_SUBLEN_MP_CAPABLE_ACK) {
+			break;
+		}
+
+		/* indicate we have mptcp options present */
+		to->to_flags |= TOF_MPTCP;
+		to->to_mopts.mpo_flags |= MPOF_MP_CAPABLE;
+
+		if ((flags & TO_SYN) &&
+				(optlen == MPTCP_SUBLEN_MP_CAPABLE_SYN)) {
+
+				bcopy((char *)cp,(char *)&mcap,
+						sizeof(struct mp_capable));
+
+				/* using checksums? */
+				if (mcap.flags & USE_CSUM) {
+					to->to_mopts.mpo_flags |= MPOF_USE_CSUM;
+				}
+
+				/* need to save the incoming key */
+				bcopy((char *)cp + MP_REMOTE_KEY_OFFSET,
+						(char *)&to->to_mopts.remote_key,
+						sizeof(to->to_mopts.remote_key));
+		}
+
+		if (optlen == MPTCP_SUBLEN_MP_CAPABLE_ACK) {
+			/* do some validation here */
+		}
+		break;
+	}
+	case MPTCP_SUBTYPE_DSS:
+	{
+			byte_offset = 0;
+			uint8_t	dss_flags;
+
+			to->to_mopts.mpo_flags |= MPOF_DSS;
+			bcopy((char *)cp + MP_DSS_FLAGS_OFFSET,(char *)&dss_flags,
+							sizeof(uint8_t));
+
+			/* Data-FIN present */
+			if(dss_flags & FIN_PRESENT)
+				to->to_mopts.mpo_flags |= MPOF_DATA_FIN;
+
+			/* Data-ACK present */
+			if (dss_flags & ACK_PRESENT) {
+				// set flag that we have an ACK
+				to->to_mopts.mpo_flags |= MPOF_DATA_ACK;
+
+				/* Is 64-bit Data ACK present */
+				if (dss_flags & ACK_64_PRESENT) {
+					to->to_mopts.mpo_flags |= MPOF_ACK64;
+					// grabbing whole 64-bits
+					bcopy((char *)cp + MP_DATA_ACK64_OFFSET,
+						(char *)&to->to_mopts.data_ack_num,
+						sizeof(to->to_mopts.data_ack_num));
+					to->to_mopts.data_ack_num =
+							be64toh(to->to_mopts.data_ack_num);
+					// offset the presence of 64-bit ACK
+					byte_offset += 8;
+				} else {
+					uint32_t short_data_ack;
+					bcopy((char *)cp + MP_DATA_ACK_OFFSET,
+						(char *)&short_data_ack,
+						sizeof(short_data_ack));
+					to->to_mopts.data_ack_num = ntohl(short_data_ack);
+					byte_offset += 4; // offset the presence of 32-bit ACK
+				}
+			}
+
+			/* DSN, SSN, length and csum present */
+			if (dss_flags & MAP_PRESENT) {
+				/* flag the new DSN Mapping for this subflow */
+				to->to_mopts.mpo_flags |= MPOF_DSN_MAP;
+
+				/* Is DSN 8 octets */
+				if (dss_flags & DSN_64) {
+					bcopy((char *)cp + MP_DSN_OFFSET + byte_offset,
+						(char *)&to->to_mopts.data_seq_num,
+						sizeof(to->to_mopts.data_seq_num));
+					to->to_mopts.data_seq_num =
+					    be64toh(to->to_mopts.data_seq_num);
+					byte_offset += 4;
+					to->to_mopts.mpo_flags |= MPOF_DSN64;
+				} else {
+					uint32_t short_dsn;
+					bcopy((char *)cp + MP_DSN_OFFSET + byte_offset,
+						(char *)&short_dsn,
+						sizeof(short_dsn));
+					to->to_mopts.data_seq_num = (uint64_t) ntohl(short_dsn);
+				}
+
+				/* subflow sequence number */
+				bcopy((char *)cp + MP_SUB_SEQN_OFFSET + byte_offset,
+					(char *)&to->to_mopts.sub_seq_num,
+					sizeof(to->to_mopts.sub_seq_num));
+				to->to_mopts.sub_seq_num = ntohl(to->to_mopts.sub_seq_num);
+
+				/* Data-level length */
+				bcopy((char *)cp + MP_DATA_LEN_OFFSET + byte_offset,
+					(char *)&to->to_mopts.dss_data_len,
+					sizeof(to->to_mopts.dss_data_len));
+				to->to_mopts.dss_data_len = ntohs(to->to_mopts.dss_data_len);
+
+				/*
+				 * XXXNJW: need to check if using csums
+				 * should do this by checking the length of the option
+				 * at the start and keeping track along the way....
+				 */
+
+				 /* checksum */
+//					bcopy((char *)cp + MP_CSUM_OFFSET + byte_offset,
+//						(char *)&to->to_mopts.dss_csum,
+//						sizeof(to->to_mopts.dss_csum));
+//					to->to_mopts.dss_csum = ntohs(to->to_mopts.dss_csum);
+			}
+			break;
+	}
+	case MPTCP_SUBTYPE_MP_JOIN:
+	{
+		if (optlen != MPTCP_SUBLEN_MP_JOIN_SYN &&
+			optlen != MPTCP_SUBLEN_MP_JOIN_SYNACK &&
+			optlen != MPTCP_SUBLEN_MP_JOIN_ACK) {
+			break;
+		}
+
+		/* can use optlen to differentiate subtype variations */
+		to->to_mopts.optlen = optlen;
+
+		switch (optlen)
+		{
+		case MPTCP_SUBLEN_MP_JOIN_SYN:
+			to->to_flags |= TOF_MPTCP;
+
+			/* copy address id */
+			bcopy((char *)cp + 3,
+					(char *)&to->to_mopts.addr_id,
+					sizeof(to->to_mopts.addr_id));
+
+			/* is this a backup path */
+			if (subtype & IS_BACKUP) {
+				to->to_mopts.mpo_flags |= MPOF_BACKUP_PATH;
+			}
+
+			/* save the local_token */
+			bcopy((char *)cp + MP_RCV_TOKEN_OFFSET,
+					(char *)&to->to_mopts.rcv_token,
+					sizeof(to->to_mopts.rcv_token));
+
+			/* save the senders random number */
+			bcopy((char *)cp + MP_SND_RND_OFFSET,
+					(char *)&to->to_mopts.snd_rnd,
+					sizeof(to->to_mopts.snd_rnd));
+			to->to_mopts.mpo_flags |= MPOF_JOIN_SYN;
+			break;
+		case MPTCP_SUBLEN_MP_JOIN_SYNACK:
+			to->to_flags |= TOF_MPTCP;
+
+			/* copy option 'header' into struct */
+			bcopy((char *)cp,(char *)&mjoin,
+				sizeof(struct mp_join));
+			/* is this a backup path */
+			if (mjoin.sub_flags & IS_BACKUP) {
+				to->to_mopts.mpo_flags |= MPOF_BACKUP_PATH;
+			}
+			/* save remote truncate MAC */
+			bcopy((char *)cp + MP_SND_MAC_OFFSET,
+			    (char *)&to->to_mopts.snd_trc_mac,
+			    sizeof(to->to_mopts.snd_trc_mac));
+
+			/* save the senders random number */
+			bcopy((char *)cp + MP_SND_RND_SYNACK_OFFSET,
+			    (char *)&to->to_mopts.snd_rnd,
+			    sizeof(to->to_mopts.snd_rnd));
+
+			to->to_mopts.mpo_flags |= MPOF_JOIN_SYNACK;
+			break;
+		case MPTCP_SUBLEN_MP_JOIN_ACK:
+			to->to_flags |= TOF_MPTCP;
+
+			/* just take a pointer to the hmac. We can copy the bytes in
+			 * syncache_expand_subflow as the memory will still be valid */
+			to->to_mopts.snd_mac = (char *)cp + MP_SND_MAC_OFFSET;
+
+			to->to_mopts.mpo_flags |= MPOF_JOIN_ACK;
+			to->to_mopts.mpo_flags |= MPOF_NEED_ACK;
+			break;
+		}
+		break;
+	}
+	case MPTCP_SUBTYPE_ADD_ADDR:
+	{
+		/* not using the port number field for now */
+		if (optlen != MPTCP_SUBLEN_ADD_ADDRV4 &&
+		    optlen != MPTCP_SUBLEN_ADD_ADDRV6)
+				break;
+
+		void * addr = NULL;
+		int addr_len = 0;
+
+		switch (optlen)
+		{
+		case MPTCP_SUBLEN_ADD_ADDRV4:
+			to->to_mopts.mpo_flags |= MPOF_ADD_ADDR_V4;
+			addr = &((struct sockaddr_in *)
+					&to->to_mopts.new_addr)->sin_addr.s_addr;
+			addr_len = 4;
+			/* Copy address ID */
+			break;
+		case MPTCP_SUBLEN_ADD_ADDRV6:
+			to->to_mopts.mpo_flags |= MPOF_ADD_ADDR_V6;
+			/* Copy INET address */
+			addr = &((struct sockaddr_in6 *)
+					&to->to_mopts.new_addr)->sin6_addr.__u6_addr;
+			addr_len = 16;
+			break;
+		}
+		/* Copy INET address */
+		bcopy((char *)cp + MP_ADD_ADDR_OFFSET, addr,
+		    addr_len);
+
+		char buf[128];
+		inet_ntop(AF_INET, &(((struct in_addr *) addr)->s_addr), buf, sizeof(buf));
+		mp_debug(MPSESSION, 4, 0, "option add_addr %s\n", buf);
+
+		/* Copy address ID */
+		bcopy((char *)cp + MP_ADDID_OFFSET,
+		    (char *)&to->to_mopts.addr_id,
+		    sizeof(to->to_mopts.addr_id));
+		break;
+	}
+	case MPTCP_SUBTYPE_REMOVE_ADDR:
+	{
+		break;
+	}
+	case MPTCP_SUBTYPE_MP_PRIO:
+	{
+		break;
+	}
+	case MPTCP_SUBTYPE_MP_FAIL:
+	{
+
+		break;
+	}
+	case MPTCP_SUBTYPE_MP_FASTCLOSE:
+	{
+		if (optlen != MPTCP_SUBTYPELEN_MP_FASTCLOSE)
+			break;
+
+		to->to_mopts.mpo_flags |= MPOF_FASTCLOSE;
+
+		bcopy((char *)cp + MP_FAIL_KEY_OFFSET,
+			(char *)&to->to_mopts.local_key,
+			sizeof(&to->to_mopts.local_key));
+		break;
+	}
+	} /* end of switch */
+}
+
 /*
  * Wrapper for the TCP established input helper hook.
  */
@@ -286,11 +629,12 @@
  * CC wrapper hook functions
  */
 static void inline
-cc_ack_received(struct tcpcb *tp, struct tcphdr *th, uint16_t type)
+cc_ack_received(struct tcpcb *tp, struct tcphdr *th, uint16_t type,
+    uint32_t acked)
 {
 	INP_WLOCK_ASSERT(tp->t_inpcb);
 
-	tp->ccv->bytes_this_ack = BYTES_THIS_ACK(tp, th);
+	tp->ccv->bytes_this_ack = acked;
 	if (tp->snd_cwnd <= tp->snd_wnd)
 		tp->ccv->flags |= CCF_CWND_LIMITED;
 	else
@@ -868,8 +1212,20 @@
 		    th->th_sport, ip->ip_dst, th->th_dport,
 		    INPLOOKUP_WILDCARD | INPLOOKUP_WLOCKPCB,
 		    m->m_pkthdr.rcvif, m);
+
 #endif /* INET */
 
+
+	if (thflags & TH_SYN) {
+		/* debug output for addresses */
+		char buf[128];
+		inet_ntop(AF_INET, &ip->ip_src, buf, sizeof(buf));
+		mp_debug(MPSESSION, 4, 0, "%s: SYN from %s port %d to ", __func__,
+			buf, ntohs(th->th_sport));
+		inet_ntop(AF_INET, &ip->ip_dst, buf, sizeof(buf));
+		mp_debug(MPSESSION, 4, 0, "%s port %d\n", buf, ntohs(th->th_dport));
+	}
+
 	/*
 	 * If the INPCB does not exist then all data in the incoming
 	 * segment is discarded and an appropriate RST is sent back.
@@ -919,6 +1275,7 @@
 	}
 #endif /* IPSEC */
 
+
 	/*
 	 * Check the minimum TTL for socket.
 	 */
@@ -1044,6 +1401,7 @@
 		tcp_savetcp = *th;
 	}
 #endif /* TCPDEBUG */
+
 	/*
 	 * When the socket is accepting connections (the INPCB is in LISTEN
 	 * state) we look into the SYN cache if this is a new connection
@@ -1051,8 +1409,12 @@
 	 * sockets are never in TCPS_ESTABLISHED, the V_tcbinfo lock will be
 	 * held in this case.
 	 */
-	if (so->so_options & SO_ACCEPTCONN) {
+	if ((so->so_options & SO_ACCEPTCONN)
+	    || (tp->t_mpcb->mp_state == MPS_ESTABLISHED && !IS_MASTER_TP(tp)
+	    && tp->t_state == TCPS_LISTEN
+	    && (so->so_options & SO_ACCEPTCONN) == 0)) {	//XXXNJW this is not pretty
 		struct in_conninfo inc;
+		int is_subflow = 0;
 
 		KASSERT(tp->t_state == TCPS_LISTEN, ("%s: so accepting but "
 		    "tp not listening", __func__));
@@ -1080,17 +1442,38 @@
 		 * socket appended to the listen queue in SYN_RECEIVED state.
 		 */
 		if ((thflags & (TH_RST|TH_ACK|TH_SYN)) == TH_ACK) {
+			int expand_result = 0;
 			/*
 			 * Parse the TCP options here because
 			 * syncookies need access to the reflected
 			 * timestamp.
 			 */
 			tcp_dooptions(&to, optp, optlen, 0);
+
+			/*
+			 * check for an mp_join option on the ACK. this means
+			 * that the handshake is for a mptcp subflow - thus
+			 * the path from here on should be different.
+			 *
+			 * might need to alter syncache_expand (dont't actually
+			 * want to allocate a new socket for a subflow, as it
+			 * should be associated with the socket of the master_tp
+			 *
+			 */
+
 			/*
 			 * NB: syncache_expand() doesn't unlock
 			 * inp and tcpinfo locks.
 			 */
-			if (!syncache_expand(&inc, &to, th, &so, m)) {
+			if (to.to_mopts.mpo_flags & MPOF_JOIN_ACK) {
+				expand_result =
+				    syncache_expand_subflow(&inc, &to, th, &so, m);
+				is_subflow = 1;
+			} else {
+				expand_result = syncache_expand(&inc, &to, th, &so, m);
+			}
+
+			if(!expand_result) {
 				/*
 				 * No syncache entry or ACK was not
 				 * for our SYN/ACK.  Send a RST.
@@ -1100,6 +1483,7 @@
 				rstreason = BANDLIM_RST_OPENPORT;
 				goto dropwithreset;
 			}
+
 			if (so == NULL) {
 				/*
 				 * We completed the 3-way handshake
@@ -1124,17 +1508,27 @@
 				} else
 					goto dropunlock;
 			}
-			/*
-			 * Socket is created in state SYN_RECEIVED.
-			 * Unlock the listen socket, lock the newly
-			 * created socket and update the tp variable.
-			 */
-			INP_WUNLOCK(inp);	/* listen socket */
-			inp = sotoinpcb(so);
-			INP_WLOCK(inp);		/* new connection */
-			tp = intotcpcb(inp);
+
+			INP_WUNLOCK(inp); /* listen socket */
+
+			/* need to get the inp for the sublfow */
+			if (is_subflow) {
+				tp = SLIST_FIRST(&intotcpcb(sotoinpcb(so))->t_mpcb->tp_list);
+			} else {
+				tp = intotcpcb(sotoinpcb(so));
+			}
+
+//			printf("%s: got SYN, printing tp pointers\n", __func__);
+//			struct tcpcb *sf_tp = NULL;
+//			SLIST_FOREACH(sf_tp, &intotcpcb(sotoinpcb(so))->t_mpcb->tp_list,
+//			    next_subflow) {
+//				printf("%s: sf_tp %p\n", __func__, sf_tp);
+//			}
+
+			INP_WLOCK(tp->t_inpcb); /* new connection */
 			KASSERT(tp->t_state == TCPS_SYN_RECEIVED,
-			    ("%s: ", __func__));
+			    ("%s: expanded tp not in SYN_RECEIVED", __func__));
+
 #ifdef TCP_SIGNATURE
 			if (sig_checked == 0)  {
 				tcp_dooptions(&to, optp, optlen,
@@ -1165,6 +1559,8 @@
 			INP_INFO_UNLOCK_ASSERT(&V_tcbinfo);
 			return;
 		}
+		/* end syncache check on ACK */
+
 		/*
 		 * Segment flag validation for new connection attempts:
 		 *
@@ -1356,7 +1752,9 @@
 			tcp_trace(TA_INPUT, ostate, tp,
 			    (void *)tcp_saveipgen, &tcp_savetcp, 0);
 #endif
+
 		tcp_dooptions(&to, optp, optlen, TO_SYN);
+
 		syncache_add(&inc, &to, th, inp, &so, m, NULL, NULL);
 		/*
 		 * Entry added to syncache and mbuf consumed.
@@ -1460,14 +1858,16 @@
     struct tcpcb *tp, int drop_hdrlen, int tlen, uint8_t iptos,
     int ti_locked)
 {
-	int thflags, acked, ourfinisacked, needoutput = 0;
-	int rstreason, todrop, win;
+	int thflags, acked = 0, ourfinisacked, oursynisacked = 0, needoutput = 0;
+	int rstreason = 0, todrop, win;
 	u_long tiwin;
 	char *s;
 	struct in_conninfo *inc;
-	struct mbuf *mfree;
 	struct tcpopt to;
 
+	struct mpcb *mp = tp->t_mpcb;
+	struct ds_map* map = NULL;
+
 #ifdef TCPDEBUG
 	/*
 	 * The size of tcp_saveipgen must be the size of the max ip header,
@@ -1523,7 +1923,24 @@
 	 * Unscale the window into a 32-bit value.
 	 * For the SYN_SENT state the scale is zero.
 	 */
-	tiwin = th->th_win << tp->snd_scale;
+	if (!tp->mp_active)
+		tiwin = th->th_win << tp->snd_scale;
+	else
+		tiwin = tp->t_mpcb->ds_snd_wnd << tp->snd_scale;;
+
+	// XXXNJW connection wide rcv window
+	// tiwin should be set to the mp level window.
+
+	/*
+	 * RST will not have the ACK field set (th_ack == 0). Check for TH_RST
+	 * as calling BYTES_THIS_ACK with zero will trigger a false wrap detection.
+	 */
+	if (((thflags & TH_RST) == 0) && (th->th_flags & TH_ACK))
+		acked = BYTES_THIS_ACK(tp, th);
+
+	if (thflags & TH_RST) {
+		acked = 0;
+	}
 
 	/*
 	 * TCP ECN processing.
